' Tuto n4

' Tutorial  propos de 
' T-Type version BlitzMax
' par ftbass

' email : breddabasse@hotmail.com

Rem
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	'####################   Worklog   #######################'
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	Tuto 4 :
	-	Dsyncronisation par rapprt  la frquence de l'cran
		pour afficher le fps rel
	-	Tweening
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	Tuto 3 : 
	-	Ajout d'un type bonus
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	Tuto 2 :
	-	Dplacement du joueur
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	Tuto 1 :
	-	Gestion du scrolling
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
End Rem

Strict

' Paramtres d'affichage
Global LARGEUR = 1024
Global HAUTEUR = 768
Global PROFONDEUR = 32


' Variables pour le tweening
Const twe_FramerateVoulu:Int = 60.0				' Nombre d'updates par seconde
Global twe_HeurePrecedente:Int	 = MilliSecs()	' Heure de fin de la boucle prcdente
Global twe_TpsBoucle:Float = 1.0				' Temps que met une boucle du prog principal pour s'excuter
Global twe_NbBouclesParSec:Float = 1000			' Nb de boucles par seconde
Global twe_NbBouclesRaffr:Float					' Nb de boucles apres lequel il faut raffraichir
Global twe_NbBoucles:Int = 0					' Nb de boucles depuis le dernier raffraichissement


' Variables pour le calcul du frame rate
Global FPS_Timer, FPS_Frame, FPS_FPS

' Liste chaine qui va contenir tous les fonds
Global ListeFond:Tlist = New TList
' Liste chaine qui va contenir tous les joueurs
Global ListeJoueur:Tlist = New TList
' Liste chaine qui va contenir les bonus
Global ListeBonus:Tlist = New TList

' Type Fond
Type TFond
	Field image			' Image du fond
	Field x:Int, y:Int	' Coordonnes
	Field dx:Int			' Vitesse de dfilement
	
	' Methode qui met  jour les coord du fond
	Method Update()
		x = x + dx
		If x < -1023 Then
			x = 0
		End If
	End Method
	
	' Methode qui dessine le fond
	Method Draw()
		DrawImage image, x, y
		DrawImage image, 1024 + x, y
	End Method
	
End Type

' On dfinit un type TVaisseau qui sera le parent de tous les autres Vaisseau
Type TVaisseau

	Field Image
	Field X:Int = MouseX()				' Position X
	Field Y:Int = MouseY()				' Position Y
	Field NumImage:Int				' Numro de l'image  afficher
	Field Vitesse:Int = 1				' Coefficient pour la vitesse du vaisseau
	Field Bouclier:Int				' Niveau de vie du vaisseau
	Field Timer:Int = MilliSecs()		' Timer pour les animations
	Field Tempo:Int = 30				' Tempo entre chaque animation
	Field DirV:String = "null"			' Direction verticale
	Field Etat:String = "vivant"		' Etat du vaiseau (vivant, mort, invincible)

	
	' Mise  jour des vaisseaux
	Method Update() Abstract

	' Dessin des vaisseaux
	Method Draw()
		DrawImage Image, X, Y, NumImage
	End Method
	
End Type


' Type Bonus
Type TBonus Extends TVaisseau

	Field TypeBonus:Int			' Bonus de tir ou de vitesse
	Field YIni:Int				' Position Y initiale
	
	
	Method Update()
		
		X = X - 3 * Vitesse
		Y = YIni + Cos((MilliSecs() + 1000) / 3) * 50
		
		If (Timer + Tempo < MilliSecs()) Then
			If(NumImage < 19) Then
				NumImage = NumImage + 1
				Timer = MilliSecs()
			Else
				NumImage = 0
			End If			
		End If
		
		If Self.x < 0 - 64 Then
			ListeBonus.Remove Self
		End If
		
	End Method
	
End Type

' Type TJoueur hrit du type TVaisseau
Type TJoueur Extends TVaisseau

	Method Update()
		If KeyDown(KEY_LEFT) And X >= -10 Then
			X = X - 3 * Vitesse
		EndIf
		If KeyDown(KEY_RIGHT) And X <= (LARGEUR - 112) Then
			X = X + 3 * Vitesse
		EndIf
		If KeyHit(KEY_UP) And Not(KeyDown(KEY_DOWN))
			DirV = "haut"
			NumImage = 11
			Timer = MilliSecs()
		End If
		If KeyDown(KEY_UP)
			If Y >= -40 Then
				Y = Y - 3 * Vitesse
			End If
			If (Timer + Tempo < MilliSecs()) And (NumImage < 21) Then
				NumImage = NumImage + 1
				Timer = MilliSecs()
			End If
		EndIf
		If KeyHit(KEY_DOWN) And Not(KeyDown(KEY_UP))
			DirV = "bas"
			NumImage = 0
			Timer = MilliSecs()
		End If
		If KeyDown(KEY_DOWN)
			If Y <= 680 Then
				Y = Y + 3 * Vitesse
			End If
			If (Timer + Tempo < MilliSecs()) And (NumImage < 10) Then
				NumImage = NumImage + 1
				Timer = MilliSecs()
			End If
		EndIf
		If Not(KeyDown(KEY_DOWN) Or KeyDown(KEY_UP))
			Select DirV
				Case "haut"
					If (Timer + Tempo < MilliSecs()) And (NumImage > 11) Then
						NumImage = NumImage - 1
						Timer = MilliSecs()
					ElseIf NumImage = 11 Then
						DirV = "null"
					End If
				Case "bas"
					If (Timer + Tempo < MilliSecs()) And (NumImage > 0) Then
						NumImage = NumImage - 1
						Timer = MilliSecs()
					ElseIf NumImage = 0 Then
						DirV = "null"
					End If
			End Select
		End If
	End Method
	
End Type



Graphics LARGEUR, HAUTEUR, PROFONDEUR
HideMouse

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Mdias du jeu
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Fonds
Global gfxFond1 = LoadImage("Medias/Images/Fond_Plan_1.png")
Global gfxFond2 = LoadImage("Medias/Images/Fond_Plan_2.png")
' Joueur
Global gfxJoueur = LoadAnimImage("Medias/Images/Play_All_Glued2.png", 128, 128, 0, 22)
' Bonus
Global gfxBonusV = LoadAnimImage("Medias/Images/Item1_Glued.png", 64, 64, 0, 20)
Global gfxBonusT = LoadAnimImage("Medias/Images/Item2_Glued.png", 64, 64, 0, 20)


'Local Joueur1 = New(TJoueur)
'ListeJoueur.AddLast Joueur1



Rem 
			On cre 2 objets de Type TFond
			Avec des vitesses diffrentes
			Ce qui va permettre de donner 
			une impression de profondeur
End Rem
CreateFond(gfxFond2, 0, 0, -2)
CreateFond(gfxFond1, 0, 0, -3)

CreateJoueur()
CreateBonus(1024, 600, "Vitesse")

bglSetSwapInterval ( 0)


While Not KeyHit(KEY_ESCAPE)
	
	Cls
	
	UpdateGame()
	RenderGame()
	
	DrawText "Memoire allouee par l'application : " + MemAlloced(), 0, 0
	DrawText "FPS = " + FPS(), 0, 10
	
	bglSwapBuffers()
	
	FlushMem

Wend




' Mise  jour de tous les lments du jeu
Function UpdateGame()

	Local Fond : TFond
	Local Joueur : TJoueur
	Local Bonus : TBonus

	Rem
		Si on doit raffrachir les lments du jeu, 
		suivant le framerate qu'on a choisi (twe_FramerateVoulu),
		alors on update tout
	End Rem
	If Raffraichir() Then

		' Mise  jour des fond
		For Fond=EachIn ListeFond
   	 		Fond.Update()
  		Next
	
		' Mise  jour des bonus
		For Bonus=EachIn ListeBonus
   	 		Bonus.Update()
  		Next
	
		' Mise  jour des joueurs
		For Joueur=EachIn ListeJoueur
   	 		Joueur.Update()
  		Next

	End If

End Function


' Affichage de tous les lments du jeu
Function RenderGame()

	Local Fond : TFond
	Local Joueur : TJoueur
	Local Bonus : TBonus

	' Affichage des fonds
	For Fond=EachIn ListeFond
    		Fond.Draw()
  	Next

	' Affichage des bonus
	For Bonus=EachIn ListeBonus
    		Bonus.Draw()
  	Next

	' Affichage des joueurs
	For Joueur=EachIn ListeJoueur
    		Joueur.Draw()
  	Next

End Function


' Creation d'un objet Fond
Function CreateFond:TFond(image, x:Int, y:Int, dx:Int)

	Local f:TFond = New TFond
			
	f.image = image
	f.x = x
	f.y = y
	f.dx = dx
	' On l'ajoute  la liste des fonds
	ListAddLast ListeFond, f
	Return f

End Function


' Cration d'un objet de type Joueur
Function CreateJoueur:TJoueur()

	Local j:TJoueur = New TJoueur
	
	j.Image = gfxJoueur
	ListAddLast ListeJoueur, j
	Return j
	
End Function


' Creation d'un objet de type Bonus
Function CreateBonus:TBonus(x:Int, yIni:Int, TypeBonus$)
	
	Local b:TBonus = New TBonus
	
	Select TypeBonus
		Case "Vitesse"
			b.Image = gfxBonusV	
		Case "Tir"
			b.Image = gfxBonusT
	End Select
	
	b.X = x
	b.YIni = yIni
	ListAddLast ListeBonus, b
	Return b
	
End Function


' Fonction qui calcule les FPS
Function FPS:Int()

	If (MilliSecs() < (FPS_Timer + 1000)) Then 
		FPS_Frame = FPS_Frame + 1 
	Else 
		FPS_FPS = FPS_Frame 
		FPS_Frame = 0 
		FPS_Timer = MilliSecs() 
	End If 
	Return FPS_FPS
	
End Function


' Fonction qui va dtecter les collisions
Function TestCollisions()

	Local Joueur : TJoueur
	Local Bonus : TBonus

	For Joueur=EachIn ListeJoueur
    		For Bonus=EachIn ListeBonus

		Next
  	Next

End Function

' Fonction qui nous dit si on doit raffraichir suivant le framerate slectionn
Function Raffraichir()
	
	twe_NbBoucles = twe_NbBoucles + 1
	twe_TpsBoucle = MilliSecs() - twe_HeurePrecedente
	twe_HeurePrecedente = MilliSecs()
	twe_NbBouclesParSec = 1000 / twe_TpsBoucle

	If (1000 / twe_TpsBoucle) < twe_NbBouclesParSec Then
		twe_NbBouclesParSec = (1000 / twe_TpsBoucle)
		twe_NbBouclesRaffr = (twe_NbBouclesParSec / twe_FramerateVoulu)
	End If
	
	If twe_NbBoucles > twe_NbBouclesRaffr Then
		twe_NbBoucles = 0
		Return True
	Else
		Return False
	End If

End Function


